package VR.prob

import VR.data.DataClass

/**
  * Created by YY on 2016/1/9.
  */
class LinearRegression extends ProblemBase[DataClass] {

  override protected def row_objective_cal(w:Array[Double], data:DataClass, row:Int):Double = 0.5* sqr(inner_sparse(w,data.x(row))-data.y(row))


  override def gradient_cal(w:Array[Double],dat:DataClass, row:Int):Array[Double]=  {
    val multi:Double=inner_sparse(w,dat.x(row))-dat.y(row)
    val output=new Array[Double](dat.x(row).length)
    for (i<-dat.x(row).indices)
      output(i)=multi*dat.x(row)(i)._2
    output
  }

  override def binary_alpha_cal(alpha: Double, w: Array[Double], dat:DataClass, row:Int,lambda:Double,n:Int): Double = {
    var first:Double= -100000000
    var last:Double= 10000000
    var middle:Double=0
    var part1:Double=0
    for (iter<-dat.x(row))
      part1+=w(iter._1) * iter._2
    var part2:Double=0
    for (iter<-dat.x(row))
      part2 +=iter._2*iter._2
    part2*=1.0/lambda/n
    while (last-first>=1e-12){
      middle=(first+last)/2
      val t1:Double = -alpha-middle+dat.y(row) - part1-part2*middle
      if (t1<0) last=middle else first=middle
    }
    (first+last)/2
  }
}
