package VR.prob

import VR._
import VR.data.DataClass

/**
  * Created by YY on 2016/1/9.
  */
abstract class ProblemBase [T<: DataClass]{
  def sqr(a:Double)= a*a

  protected def inner_sparse(w: Array[Double], x: Single_x_type): Double= {
    var sum: Double = 0
    for (item <- x)
      sum += w(item._1) * item._2
    sum
  }
  protected def row_objective_cal(w:Array[Double], dat:T, row:Int):Double
  def gradient_cal(w:Array[Double],dat:T, row:Int ):Array[Double]
  def binary_alpha_cal(alpha:Double,w:Array[Double], dat:T, row:Int, lambda:Double, n:Int):Double

  def full_obj_cal(data:T, w: Array[Double], lambda: Double, sigma: Double):Double={
    var sum:Double=0
    val y_dat= data.y
    for (i<- y_dat.indices) sum+= row_objective_cal(w,data, i)
    sum/= y_dat.length
    for (i<-w.indices)  sum+= sigma * math.abs(w(i)) + lambda/2 * sqr(w(i))
    sum
  }
  def fullGrad(dat:T, w:Array[Double], utilde:Array[Double]): Unit={
    for (i<-utilde.indices) utilde(i)=0
    val n=dat.n
    for (i<-Range(0,n) ){
      val tmp=gradient_cal(w,dat,i)
      for (j<-dat.x(i).indices)
        utilde(dat.x(i)(j)._1) += tmp(j)
    }
    for (i<-utilde.indices) utilde(i) /= n
  }
  def predict(w:Array[Double], x:Single_x_type): Int= if (inner_sparse(w,x)>=0) 1 else 0
}
